## ros-kinetic-visp-tracker 0.12.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(visp_tracker)

find_package(Boost REQUIRED COMPONENTS filesystem thread)

find_package(catkin REQUIRED COMPONENTS
  dynamic_reconfigure
  geometry_msgs
  image_proc
  image_transport
  message_generation
  nodelet
  resource_retriever
  roscpp
  rospy
  sensor_msgs
  std_msgs
  tf
  )

# ViSP cannot be found by Catkin.
# see https://github.com/ros/catkin/issues/606
find_package(VISP REQUIRED)


# Generate messages and services.
add_message_files(
  DIRECTORY 
    msg
  FILES
    KltPoint.msg
    KltPoints.msg
    KltSettings.msg
    MovingEdgeSettings.msg
    MovingEdgeSite.msg
    MovingEdgeSites.msg
    TrackerSettings.msg
  )
  
add_service_files(
  DIRECTORY 
    srv
  FILES
    Init.srv
  )
generate_messages(DEPENDENCIES geometry_msgs sensor_msgs std_msgs)

# Dynamic reconfigure.
generate_dynamic_reconfigure_options(
    cfg/ModelBasedSettings.cfg
    cfg/ModelBasedSettingsEdge.cfg
    cfg/ModelBasedSettingsKlt.cfg)


catkin_package(
  LIBRARIES
    trackerNodelet
    ${PROJECT_NAME} 

  CATKIN_DEPENDS
    dynamic_reconfigure
    geometry_msgs
    message_runtime
    nodelet
    roscpp
    sensor_msgs
    std_msgs
    tf

  DEPENDS
    VISP
  )

include_directories(SYSTEM
  ${Boost_INCLUDE_DIRS}
  ${VISP_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
  )

include_directories(
  "${CMAKE_CURRENT_SOURCE_DIR}/src/lib${PROJECT_NAME}")

# Make sure Boost.Filesystem v3 is used.
add_definitions(-DBOOST_FILESYSTEM_VERSION=3)

#############
# Libraries #
#############

# Library gathering libvisp_tracker used by all nodes.
add_library(${PROJECT_NAME}
  src/lib${PROJECT_NAME}/callbacks.cpp
  src/lib${PROJECT_NAME}/callbacks.hh
  src/lib${PROJECT_NAME}/conversion.cpp
  src/lib${PROJECT_NAME}/conversion.hh
  src/lib${PROJECT_NAME}/file.cpp
  src/lib${PROJECT_NAME}/file.hh
  src/lib${PROJECT_NAME}/names.cpp
  src/lib${PROJECT_NAME}/names.hh
  src/lib${PROJECT_NAME}/tracker-client.cpp
  src/lib${PROJECT_NAME}/tracker-client.hh
  src/lib${PROJECT_NAME}/tracker-viewer.cpp
  src/lib${PROJECT_NAME}/tracker-viewer.hh
  src/lib${PROJECT_NAME}/tracker.cpp
  src/lib${PROJECT_NAME}/tracker.hh)

target_link_libraries(${PROJECT_NAME}
  ${Boost_LIBRARIES}
  ${VISP_LIBRARIES}
  )
target_link_libraries(${PROJECT_NAME}
  ${dynamic_reconfigure_LIBRARIES}
  ${geometry_msgs_LIBRARIES}
  ${image_proc_LIBRARIES}
  ${image_transport_LIBRARIES}
  ${message_generation_LIBRARIES}
  ${nodelet_LIBRARIES}
  ${resource_retriever_LIBRARIES}
  ${roscpp_LIBRARIES}
  ${sensor_msgs_LIBRARIES}
  ${std_msgs_LIBRARIES}
  ${tf_LIBRARIES}
  )

if(CATKIN_ENABLE_TESTING)
  add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_gencpp ${PROJECT_NAME}_bag)
else()
  add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_gencpp)
endif()
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS})

install(DIRECTORY src/lib${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)
install(DIRECTORY cfg/cpp/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

############
# Nodelets #
############

# Tracker, client, viewer nodelets.
add_library(trackerNodelet
  src/nodelets/client.cpp
  src/nodelets/tracker.cpp
  src/nodelets/viewer.cpp)

target_link_libraries(trackerNodelet ${PROJECT_NAME})
target_link_libraries(trackerNodelet
  ${roscpp_LIBRARIES}
  ${nodelet_LIBRARIES}
  ${VISP_LIBRARIES}
  )

install(TARGETS trackerNodelet ${PROJECT_NAME}
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)


########
# Node #
########

add_executable(tracker src/nodes/tracker.cpp)
target_link_libraries(tracker
  ${roscpp_LIBRARIES}
  ${nodelet_LIBRARIES})

add_executable(${PROJECT_NAME}_client src/nodes/client.cpp)
target_link_libraries(${PROJECT_NAME}_client
  ${roscpp_LIBRARIES}
  ${nodelet_LIBRARIES})

add_executable(${PROJECT_NAME}_viewer src/nodes/viewer.cpp)
target_link_libraries(${PROJECT_NAME}_viewer
  ${roscpp_LIBRARIES}
  ${nodelet_LIBRARIES})

add_dependencies(tracker ${${PROJECT_NAME}_EXPORTED_TARGETS})
add_dependencies(${PROJECT_NAME}_client ${${PROJECT_NAME}_EXPORTED_TARGETS})

install(TARGETS tracker ${PROJECT_NAME}_client ${PROJECT_NAME}_viewer
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(PROGRAMS scripts/tf_localization.py
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(FILES nodelet_plugins.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})


#############
# Bag files #
#############

# Tutorial
if(CATKIN_ENABLE_TESTING)
  catkin_download_test_data(
    ${PROJECT_NAME}_bag
    https://github.com/lagadic/vision_visp/releases/download/vision_visp-0.5.0/tutorial-static-box.bag
    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/bag
    MD5 1578dedd48d3f9f5515a8737845ae882)

  install(DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/bag
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  )
endif()

install(DIRECTORY models
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-kinetic-visp-tracker (0.12.0-1xenial) xenial; urgency=high



 -- Fabien Spindler <fabien.spindler@inria.fr>  Wed, 10 Mar 2021 23:00:00 -0000

ros-kinetic-visp-tracker (0.11.1-1xenial) xenial; urgency=high



 -- Fabien Spindler <fabien.spindler@inria.fr>  Wed, 03 Jul 2019 22:00:00 -0000

ros-kinetic-visp-tracker (0.11.0-1xenial) xenial; urgency=high

  * Update with Melodic
  * Fix memory leak
  * Introduce vpMbGenericTracker and visp3 headers in visp_auto_tracker
  * Introduce visp3 headers
  * Code indentation
  * Introduce vpMbGenericTracker
  * Introduce vpHandEyeCalibration class
  * Fix build for melodic (Closes #88)
  * Fix compilation on 17.04 by adding missing boost/format.hpp inclusion
  * Contributors: Fabien Spindler

 -- Fabien Spindler <fabien.spindler@inria.fr>  Sun, 26 May 2019 22:00:00 -0000

ros-kinetic-visp-tracker (0.10.0-1xenial) xenial; urgency=high

  * Fix catkin_lint warnings level 2
  * Fix OpenCV issue when reconfiguring the visp_tracker (Closes #58 <https://github.com/lagadic/vision_visp/issues/58>)
  * kinetic-0.9.3
  * Prepare changelogs
  * Contributors: Fabien Spindler

 -- Fabien Spindler <fabien.spindler@inria.fr>  Thu, 09 Feb 2017 23:00:00 -0000

ros-kinetic-visp-tracker (0.9.3-1xenial) xenial; urgency=high

  * kinetic-0.9.2
  * Cleanify code
  * jade-0.9.1
  * Prepare changelogs
  * Contributors: Fabien Spindler

 -- Fabien Spindler <fabien.spindler@inria.fr>  Thu, 19 May 2016 22:00:00 -0000

ros-kinetic-visp-tracker (0.9.1-1xenial) xenial; urgency=high

  * Revert build_depend visp removal that is mandatory.
  * jade-0.9.0
  * Prepare changelogs
  * Contributors: Fabien Spindler

 -- Fabien Spindler <fabien.spindler@inria.fr>  Sun, 20 Dec 2015 23:00:00 -0000

ros-kinetic-visp-tracker (0.9.0-1xenial) xenial; urgency=high

  * Fix catkin_lint error and issues
  * Compat with ViSP 3.0.0
  * Fix to build with ViSP 2.10.0 when VISP_BUILD_DEPRECATED=OFF
  * Fix bug to display the last computed pose in the tracker client.
  * Improve data synchronization test based only on pose, klt points, and moving edges features
  * Make ROS warn messages more explicit
  * Make dynamic reconfigure working with ViSP 2.9.0.
    Ensure that the image is ready (test image size != 0) during dynamic reconfigure initialisation.
  * Use VP_VERSION_INT
  * Fix compat with ViSP 2.9.0. Fix ROS_INFO message. Code indentation.
  * Improve ROS debug messages to be more generic.
    Remove parameters that should not be modified by the user in dynamic reconfigure files.
  * Improve viewer node to handle dynamic reconfigure modifications.
    Modify tutorials so that they use the new functionnalities.
  * Fix bug in visp_tracker_client to work without visp_tracker_viewer.
  * jade-0.8.0
  * Prepare changelogs
  * Remove useless call to setKltOpencv and setMovingEdge (as it is done by default by the reconfigure server).
    Remove useless vpKltOpencv and vpMe variables.
  * Modify dynamic reconfigure files to suppressed deprecated values.
    Adapt library to work with those modifications.
    Fix ROS debug message error.
  * Reorganise ROS debug message to display trackers, edges and KLT parameters value.
  * Contributors: Aurelien Yol, Fabien Spindler

 -- Fabien Spindler <fabien.spindler@inria.fr>  Sat, 19 Dec 2015 23:00:00 -0000

ros-kinetic-visp-tracker (0.8.0-1xenial) xenial; urgency=high

  * Remove catkin_lint issues and warnings
  * Fix doc url location
  * Fix hard coded "protected to public" for Model based trackers parameters.
  * Change warning message when viewer is waiting for initialization.
  * Change default quality value of KLT points detection.
  * Add config files for dynamic reconfigure of Edge and KLT Model based trackers.
  * Fix dynamic reconfigure for bother client and tracker.
    Add forgotten mutex.unlock() when catching errors.
  * Remove "bad suppress value" message and improve suppress state detection based on ViSP enum
  * Add frame_size parameter to the tracker client and viewer nodes that allow to
    specify the lenght (in meter) of the frame axis
  * Fix compat with ViSP-2.9.0
  * Fix to save/read initial pose from /tmp/${USER}/${model_name}.0.pos file
  * Show optional help file during initialization. To this end 2
    options are possible:
    1/ If visp_tracker_client has help_image_path parameter, we
    use this setting to display the corresponding image. Extension
    could be jpeg, not only ppm. For example, in the launch file we can have:
    <node pkg="visp_tracker" type="visp_tracker_client" name="tracker_mbt_client">
    <param name="model_path" value="package://visp_tracker/models" />
    <param name="model_name" value="laas-box" />
    <param name="help_image_path" value="/home/user/laas-box.ppm"/>
    In that case we will open a display windows with /home/user/laas-box.ppm image.
    2/ If the previous parameter is not set, we consider
    model_path/model_name/model_name + .ppm extension as image full name and path.
    Following previous example, we will display
    package://visp_tracker/models/laas-box/laas-box.ppm
  * Adapt visp_tracker to handle new message for trackers common parameters.
    Add mutex_lock() in visp_tracker_client to fix dynamic reconfigure utilisation.
    Modify ModelBasedSettings.cfg for better usage of dynamic reconfigure.
  * Add new message for trackers common parameters.
  * Show object frame
  * Introduce bug fix when tracker viewer reads wrong /model_description value.
  * Support not only wrml but also cao model files.
  * Allow to read comments in init file.
  * Remove useless debug messages.
  * Fix to set Klt config at initialization.
    To check if really necessary.
  * Merge branch 'master' of https://github.com/lagadic/vision_visp
  * From /model_decription parameter decode the type of model that is used
    (vrml or cao) to be able to consider both descriptions in the viewer
  * Tracker client and viewer can now consider not only /camera_prefix but


=== debian/control ===
Source: ros-kinetic-visp-tracker
Section: misc
Priority: optional
Maintainer: Fabien Spindler <fabien.spindler@inria.fr>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, ros-kinetic-dynamic-reconfigure, ros-kinetic-geometry-msgs, ros-kinetic-image-proc, ros-kinetic-image-transport, ros-kinetic-message-generation, ros-kinetic-nodelet, ros-kinetic-resource-retriever, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-visp
Homepage: http://wiki.ros.org/wiki/visp_tracker
Standards-Version: 3.9.2

Package: ros-kinetic-visp-tracker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-dynamic-reconfigure, ros-kinetic-geometry-msgs, ros-kinetic-image-proc, ros-kinetic-image-transport, ros-kinetic-message-generation, ros-kinetic-message-runtime, ros-kinetic-nodelet, ros-kinetic-resource-retriever, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-visp
Description: Wraps the ViSP moving edge tracker provided by the ViSP visual servoing library into a ROS package.
 This computer vision algorithm computes the pose (i.e. position and orientation) of an object in an image. It is fast enough to allow object online tracking using a camera.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-visp-tracker//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
